// Code generated by private/model/cli/gen-api/main.go. DO NOT EDIT.

// Package acmpca provides the client and types for making API
// requests to AWS Certificate Manager Private Certificate Authority.
//
// This is the Amazon Web Services Private Certificate Authority API Reference.
// It provides descriptions, syntax, and usage examples for each of the actions
// and data types involved in creating and managing a private certificate authority
// (CA) for your organization.
//
// The documentation for each action shows the API request parameters and the
// JSON response. Alternatively, you can use one of the Amazon Web Services
// SDKs to access an API that is tailored to the programming language or platform
// that you prefer. For more information, see Amazon Web Services SDKs (https://aws.amazon.com/tools/#SDKs).
//
// Each Amazon Web Services Private CA API operation has a quota that determines
// the number of times the operation can be called per second. Amazon Web Services
// Private CA throttles API requests at different rates depending on the operation.
// Throttling means that Amazon Web Services Private CA rejects an otherwise
// valid request because the request exceeds the operation's quota for the number
// of requests per second. When a request is throttled, Amazon Web Services
// Private CA returns a ThrottlingException (https://docs.aws.amazon.com/acm-pca/latest/APIReference/CommonErrors.html)
// error. Amazon Web Services Private CA does not guarantee a minimum request
// rate for APIs.
//
// To see an up-to-date list of your Amazon Web Services Private CA quotas,
// or to request a quota increase, log into your Amazon Web Services account
// and visit the Service Quotas (https://console.aws.amazon.com/servicequotas/)
// console.
//
// See https://docs.aws.amazon.com/goto/WebAPI/acm-pca-2017-08-22 for more information on this service.
//
// See acmpca package documentation for more information.
// https://docs.aws.amazon.com/sdk-for-go/api/service/acmpca/
//
// # Using the Client
//
// To contact AWS Certificate Manager Private Certificate Authority with the SDK use the New function to create
// a new service client. With that client you can make API requests to the service.
// These clients are safe to use concurrently.
//
// See the SDK's documentation for more information on how to use the SDK.
// https://docs.aws.amazon.com/sdk-for-go/api/
//
// See aws.Config documentation for more information on configuring SDK clients.
// https://docs.aws.amazon.com/sdk-for-go/api/aws/#Config
//
// See the AWS Certificate Manager Private Certificate Authority client ACMPCA for more
// information on creating client for this service.
// https://docs.aws.amazon.com/sdk-for-go/api/service/acmpca/#New
package acmpca
