// Code generated by private/model/cli/gen-api/main.go. DO NOT EDIT.

package entityresolution

import (
	"github.com/aws/aws-sdk-go/private/protocol"
)

const (

	// ErrCodeAccessDeniedException for service response error code
	// "AccessDeniedException".
	//
	// You do not have sufficient access to perform this action. HTTP Status Code:
	// 403
	ErrCodeAccessDeniedException = "AccessDeniedException"

	// ErrCodeConflictException for service response error code
	// "ConflictException".
	//
	// The request could not be processed because of conflict in the current state
	// of the resource. Example: Workflow already exists, Schema already exists,
	// Workflow is currently running, etc. HTTP Status Code: 400
	ErrCodeConflictException = "ConflictException"

	// ErrCodeExceedsLimitException for service response error code
	// "ExceedsLimitException".
	//
	// The request was rejected because it attempted to create resources beyond
	// the current AWS Entity Resolution account limits. The error message describes
	// the limit exceeded. HTTP Status Code: 402
	ErrCodeExceedsLimitException = "ExceedsLimitException"

	// ErrCodeInternalServerException for service response error code
	// "InternalServerException".
	//
	// This exception occurs when there is an internal failure in the AWS Entity
	// Resolution service. HTTP Status Code: 500
	ErrCodeInternalServerException = "InternalServerException"

	// ErrCodeResourceNotFoundException for service response error code
	// "ResourceNotFoundException".
	//
	// The resource could not be found. HTTP Status Code: 404
	ErrCodeResourceNotFoundException = "ResourceNotFoundException"

	// ErrCodeThrottlingException for service response error code
	// "ThrottlingException".
	//
	// The request was denied due to request throttling. HTTP Status Code: 429
	ErrCodeThrottlingException = "ThrottlingException"

	// ErrCodeValidationException for service response error code
	// "ValidationException".
	//
	// The input fails to satisfy the constraints specified by AWS Entity Resolution.
	// HTTP Status Code: 400
	ErrCodeValidationException = "ValidationException"
)

var exceptionFromCode = map[string]func(protocol.ResponseMetadata) error{
	"AccessDeniedException":     newErrorAccessDeniedException,
	"ConflictException":         newErrorConflictException,
	"ExceedsLimitException":     newErrorExceedsLimitException,
	"InternalServerException":   newErrorInternalServerException,
	"ResourceNotFoundException": newErrorResourceNotFoundException,
	"ThrottlingException":       newErrorThrottlingException,
	"ValidationException":       newErrorValidationException,
}
