// Code generated by private/model/cli/gen-api/main.go. DO NOT EDIT.

// Package paymentcryptography provides the client and types for making API
// requests to Payment Cryptography Control Plane.
//
// You use the Amazon Web Services Payment Cryptography Control Plane to manage
// the encryption keys you use for payment-related cryptographic operations.
// You can create, import, export, share, manage, and delete keys. You can also
// manage Identity and Access Management (IAM) policies for keys. For more information,
// see Identity and access management (https://docs.aws.amazon.com/payment-cryptography/latest/userguide/security-iam.html)
// in the Amazon Web Services Payment Cryptography User Guide.
//
// To use encryption keys for payment-related transaction processing and associated
// cryptographic operations, you use the Amazon Web Services Payment Cryptography
// Data Plane (https://docs.aws.amazon.com/payment-cryptography/latest/DataAPIReference/Welcome.html).
// You can encrypt, decrypt, generate, verify, and translate payment-related
// cryptographic operations.
//
// All Amazon Web Services Payment Cryptography API calls must be signed and
// transmitted using Transport Layer Security (TLS). We recommend you always
// use the latest supported TLS version for logging API requests.
//
// Amazon Web Services Payment Cryptography supports CloudTrail, a service that
// logs Amazon Web Services API calls and related events for your Amazon Web
// Services account and delivers them to an Amazon S3 bucket that you specify.
// By using the information collected by CloudTrail, you can determine what
// requests were made to Amazon Web Services Payment Cryptography, who made
// the request, when it was made, and so on. If you don't conﬁgure a trail,
// you can still view the most recent events in the CloudTrail console. For
// more information, see the CloudTrail User Guide (https://docs.aws.amazon.com/awscloudtrail/latest/userguide/).
//
// See https://docs.aws.amazon.com/goto/WebAPI/payment-cryptography-2021-09-14 for more information on this service.
//
// See paymentcryptography package documentation for more information.
// https://docs.aws.amazon.com/sdk-for-go/api/service/paymentcryptography/
//
// # Using the Client
//
// To contact Payment Cryptography Control Plane with the SDK use the New function to create
// a new service client. With that client you can make API requests to the service.
// These clients are safe to use concurrently.
//
// See the SDK's documentation for more information on how to use the SDK.
// https://docs.aws.amazon.com/sdk-for-go/api/
//
// See aws.Config documentation for more information on configuring SDK clients.
// https://docs.aws.amazon.com/sdk-for-go/api/aws/#Config
//
// See the Payment Cryptography Control Plane client PaymentCryptography for more
// information on creating client for this service.
// https://docs.aws.amazon.com/sdk-for-go/api/service/paymentcryptography/#New
package paymentcryptography
