// Code generated by private/model/cli/gen-api/main.go. DO NOT EDIT.

package supportapp

import (
	"github.com/aws/aws-sdk-go/private/protocol"
)

const (

	// ErrCodeAccessDeniedException for service response error code
	// "AccessDeniedException".
	//
	// You don't have sufficient permission to perform this action.
	ErrCodeAccessDeniedException = "AccessDeniedException"

	// ErrCodeConflictException for service response error code
	// "ConflictException".
	//
	// Your request has a conflict. For example, you might receive this error if
	// you try the following:
	//
	//    * Add, update, or delete a Slack channel configuration before you add
	//    a Slack workspace to your Amazon Web Services account.
	//
	//    * Add a Slack channel configuration that already exists in your Amazon
	//    Web Services account.
	//
	//    * Delete a Slack channel configuration for a live chat channel.
	//
	//    * Delete a Slack workspace from your Amazon Web Services account that
	//    has an active live chat channel.
	//
	//    * Call the RegisterSlackWorkspaceForOrganization API from an Amazon Web
	//    Services account that doesn't belong to an organization.
	//
	//    * Call the RegisterSlackWorkspaceForOrganization API from a member account,
	//    but the management account hasn't registered that workspace yet for the
	//    organization.
	ErrCodeConflictException = "ConflictException"

	// ErrCodeInternalServerException for service response error code
	// "InternalServerException".
	//
	// We can’t process your request right now because of a server issue. Try
	// again later.
	ErrCodeInternalServerException = "InternalServerException"

	// ErrCodeResourceNotFoundException for service response error code
	// "ResourceNotFoundException".
	//
	// The specified resource is missing or doesn't exist, such as an account alias,
	// Slack channel configuration, or Slack workspace configuration.
	ErrCodeResourceNotFoundException = "ResourceNotFoundException"

	// ErrCodeServiceQuotaExceededException for service response error code
	// "ServiceQuotaExceededException".
	//
	// Your Service Quotas request exceeds the quota for the service. For example,
	// your Service Quotas request to Amazon Web Services Support App might exceed
	// the maximum number of workspaces or channels per account, or the maximum
	// number of accounts per Slack channel.
	ErrCodeServiceQuotaExceededException = "ServiceQuotaExceededException"

	// ErrCodeValidationException for service response error code
	// "ValidationException".
	//
	// Your request input doesn't meet the constraints that the Amazon Web Services
	// Support App specifies.
	ErrCodeValidationException = "ValidationException"
)

var exceptionFromCode = map[string]func(protocol.ResponseMetadata) error{
	"AccessDeniedException":         newErrorAccessDeniedException,
	"ConflictException":             newErrorConflictException,
	"InternalServerException":       newErrorInternalServerException,
	"ResourceNotFoundException":     newErrorResourceNotFoundException,
	"ServiceQuotaExceededException": newErrorServiceQuotaExceededException,
	"ValidationException":           newErrorValidationException,
}
